︠5376ed68-1c54-4b35-b437-e37b15215295︠
Author: Vincent J. Matsko
Date: 18 October 2015, Day009
Post: Creating Fractals III:  Making Your Own
︡81bd9830-2662-4bfb-900f-bfa787fe3dcf︡
︠7c6297c7-98e3-42ae-a04b-4f2a3ffddc40s︠
# Recursive function to output the highest factor of 2 within a positive integer.
# If n is odd, we're done and return 0.
# Otherwise, add 1 to the highest power of 2 within n/2.
def highestpowerof2 (n):
    if n % 2 == 1:
        return 0
    else:
        return 1 + highestpowerof2(n / 2)
︡4cb9f649-ad79-4d8e-81f9-22d326b72310︡{"done":true}︡
︠39ce2fb6-0c49-4209-9992-b5b874afd9f4s︠
highestpowerof2(1000000)
︡ae930155-5914-4e15-b951-8cb91c966cd9︡{"stdout":"6\n"}︡{"done":true}︡
︠557b1072-fccc-463f-8ca3-a7e196adce5es︠
# These are necessary so the appropriate Python commands are available.
#from graphics import *
import matplotlib

# angle1 and angle2 are the angles to turn.  IMPORTANT: Make sure angle2 is negative!
# n is the number of steps to draw.
# len is the length of the steps.
def drawfractal(angle1, angle2, n, len):
    # Color choices.  See the blog post for details.
    colors = ["darkorchid", "firebrick", "blue", "forestgreen"]
    # currentangle keeps track of the orientation in the plane.
    currentangle = 0
    # linsegments stores the lines we'll need to draw.
    linesegments = [line([vector((0,0)),vector((len,0))])]
    # currentpoint keeps track of the end of the path.
    currentpoint = vector((len,0))
    for i in range(n):
        # First, find the appropriate angle to turn.
        if highestpowerof2(i + 1) % 2 == 0:
            currentangle += angle1
        else:
            currentangle += angle2
        # Converting to rectangular coordinates.
        nextpt = currentpoint + vector((len*cos(currentangle*pi/180),len*sin(currentangle*pi/180)))
        # Now adding the segment to the end of the path.
        linesegments.append(line([currentpoint,nextpt], color=colors[i % 4]))
        # Resetting currentpoint to the end of the path.
        currentpoint = nextpt
    show(sum(linesegments), aspect_ratio = 1, axes = False)
︡78bb5308-1f76-43c3-a852-06a6e718b95a︡{"done":true}︡
︠895422cf-a816-4fc1-ac9d-8f5fb97c56ees︠
drawfractal(80, -140, 832, 0.2)

︡89129691-7c3d-4686-95db-b32663fd92ed︡{"file":{"filename":"/projects/48a4f88a-5167-45ae-a54c-f4c735940fa0/.sage/temp/compute3-us/11010/tmp_gEqYHC.svg","show":true,"text":null,"uuid":"774b343e-e11e-43ac-b5cc-8b02ccc5aa4f"},"once":false}︡{"done":true}︡
︠f392bb7c-cc91-44bf-9289-8c278a9d0808︠
drawfractal(90, -210, 128, 0.2)
︡32843fe2-ff6b-49b9-9c8f-988713e502c1︡{"once":false,"file":{"show":true,"uuid":"8e00973d-8c0a-4cce-83d6-e69e8cb9a6d0","filename":"/projects/48a4f88a-5167-45ae-a54c-f4c735940fa0/.sage/temp/compute3-us/10243/tmp_lBNVOr.svg"}}︡{"html":"<div align='center'></div>"}︡
︠38988116-0349-41cc-9cdf-b6a5cc336bb8︠
drawfractal(90, -250, 512, 0.2)
︡6730f0dd-9e20-48c9-a1fb-7c93e31d2bec︡{"once":false,"file":{"show":true,"uuid":"461531ff-c2cf-49e0-bc2e-549edf2c9967","filename":"/projects/48a4f88a-5167-45ae-a54c-f4c735940fa0/.sage/temp/compute3-us/10243/tmp_i56Wdn.svg"}}︡{"html":"<div align='center'></div>"}︡
︠aca1ec24-6269-4f8d-9023-3c007ad78bbf︠
# angle1 and angle2 are the angles to check.
# m is the maximum number of iterations to try.
# This algorithm was created by Matthieu Pluntz, October 2015.
# See the blog post for more details.
def checkangles(angle1, angle2, m):
    sum = angle1 - angle2
    currentangle = angle1
    done = False
    count = 1
    while (count <= m) and (not(done)):
        currentangle = (sum - 2 * currentangle) % 360
        count += 1
        if (currentangle == 180):
            print "Found it!", angle1, angle2, "Level = ", count
            done = True
︡cb763329-c513-4459-a83f-3123bc046541︡
︠57a52a84-06ff-4eb3-8e2f-0a310dedaaf5︠
checkangles(90, -210, 100)
︡3d96a742-8127-4635-b84d-a64dcde5db92︡{"stdout":"Found it! 90 -210 Level =  4\n"}︡
︠8deea166-2a60-4da1-af74-32192de6139c︠
checkangles(90, -250, 100)
︡0c79d27d-5b8f-4d5d-9bc9-83c8f0c7fee1︡{"stdout":"Found it! 90 -250 Level =  10\n"}︡
︠d5be1e10-921a-439d-b592-a8140376e1c8︠
checkangles(11, -169, 100)
︡14171363-596b-4e9e-b6af-7b4afc2add86︡
︠eef4784f-640b-46e7-b6a1-c93dd9fed266︠
for angle in range(-359,0):
    checkangles(90, angle, 100)
︡62763cc2-fde6-4196-aacb-47e672d137ec︡{"stdout":"Found it! 90 -354 Level =  13\nFound it! 90 -346 Level =  37\nFound it! 90 -338 Level =  37\nFound it! 90 -330 Level =  4\nFound it! 90 -322 Level =  37\nFound it! 90 -314 Level =  37\nFound it! 90 -306 Level =  5\nFound it! 90 -298 Level =  37\nFound it! 90 -290 Level =  10\nFound it! 90 -282 Level =  13\nFound it! 90 -274 Level =  37\nFound it! 90 -270 Level =  2\nFound it! 90 -266 Level =  37\nFound it! 90 -258 Level =  13\nFound it! 90 -250 Level =  10\nFound it! 90 -242 Level =  37\nFound it! 90 -234 Level =  5\nFound it! 90 -226 Level =  37\nFound it! 90 -218 Level =  37\nFound it! 90 -210 Level =  4\nFound it! 90 -202 Level =  37\nFound it! 90 -194 Level =  37\nFound it! 90 -186 Level =  13\nFound it! 90 -178 Level =  37\nFound it! 90 -170 Level =  10\nFound it! 90 -162 Level =  5\nFound it! 90 -154 Level =  37\nFound it! 90 -146 Level =  37\nFound it! 90 -138 Level =  13\nFound it! 90 -130 Level =  10\nFound it! 90 -122 Level =  37\nFound it! 90 -114 Level =  13\nFound it! 90 -106 Level =  37\nFound it! 90 -98 Level =  37\nFound it! 90 -90 Level =  3\nFound it! 90 -82 Level =  37\nFound it! 90 -74 Level =  37\nFound it! 90 -66 Level =  13\nFound it! 90 -58 Level =  37\nFound it! 90 -50 Level =  10\nFound it! 90 -42 Level =  13\nFound it! 90 -34 Level =  37\nFound it! 90 -26 Level =  37\nFound it! 90 -18 Level =  5\nFound it! 90 -10 Level =  10\nFound it! 90 -2 Level =  37\n"}︡
︠83bb72c2-4a9a-4f3f-8d8a-3637b2318a12︠
drawfractal(90, -306, 512, 0.2)
︡babb3b5a-a71e-41fb-a161-7d3d72b2c68c︡{"once":false,"file":{"show":true,"uuid":"85c0a55e-df85-46ff-82cf-59d26d520b52","filename":"/projects/48a4f88a-5167-45ae-a54c-f4c735940fa0/.sage/temp/compute3-us/10243/tmp_Z5EWNt.svg"}}︡{"html":"<div align='center'></div>"}︡
︠da890f1f-ea04-4064-af33-b035386ab751︠









